package cz.upol.database

import android.content.Context
import android.support.v7.app.AppCompatActivity
import android.os.Bundle
import android.util.Log
import android.view.Menu
import android.view.MenuItem
import android.view.View
import android.widget.EditText
import android.widget.Toast
import cz.upol.database.data.AppDb
import cz.upol.database.data.Note
import java.lang.Exception

class MainActivity : AppCompatActivity() {
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)
        setSupportActionBar(findViewById(R.id.main_toolbar))
    }

    override fun onCreateOptionsMenu(menu: Menu?): Boolean {
        menuInflater.inflate(R.menu.activity_main, menu)
        return true
    }

    override fun onOptionsItemSelected(item: MenuItem): Boolean = when (item.itemId) {
        R.id.actionAdd -> {
            Log.w("warn", "uživatel přidává!")
            true
        }

        R.id.actionSettings -> {
            Log.w("warn", "Klik na settings")
            true
        }
        else -> super.onOptionsItemSelected(item)
    }


    fun click(view: View) {
        val editText = findViewById<EditText>(R.id.input)

        val sharedPref = getPreferences(Context.MODE_PRIVATE) ?: return
        with (sharedPref.edit () ) {
            putString(getString(R.string.stored_input_key), editText.text.toString() )
            apply()
        }

        val db = AppDb.getDatabase(applicationContext) // ziskame DB
        val dao = db.noteDao() // ziskame DAO
        val note = dao.findByTitle ("Zmena")

        if (note != null) {
            dao.delete(note)
        }

        val notes = dao.getAll()
        for (note in notes) {
            Log.w("warn", note.title)
        }
    }

    fun loadClick(view: View) {
        val sharedPref = getPreferences(Context.MODE_PRIVATE) ?: return
        val storedText = sharedPref.getString(getString(R.string.stored_input_key), "")
        Toast.makeText(this, storedText, Toast.LENGTH_LONG).show()

        val text = try { assets.open("test.txt").bufferedReader().readText() }
        catch (e: Exception) {
            ""
        }
        Log.w("warn", text)
    }
}